#include <iostream.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#define LL 80       //dlina stroki programy
#define LW 8        //dlina slow
#define NW 10       //kol-vo slow
char declare[LL];
int numline=-1;
char wordn[NW][LW]={
	"",       //0
	"int",    //1
	"double", //2
	"",       //3
	"",       //4
	"cout",   //5
	"cout",   //6
	"cin",    //7
	"cin",    //8
	"="       //9
	};
char *words[NW]={
	"var",       //0
	"integer",   //1
	"real",      //2
	"begin",     //3
	"end.",      //4
	"writeln",     //5
	"write",   //6
	"readln",      //7
	"read",    //8
	":="         //9
	};
const char terminator=';',
     blist='(',
     elist=')',
     slist=',',
     apostrof='\'',
     sdeclare=':';
int numvar=0;
char var[30][LW];
char error_mes[40]="Unknown.";
FILE *prg,*cpp;

int isvar(char varname[]);
int expr(char lin[],char lout[]);
int write(char lin[],char lout[],int slowo);
int read(char lin[],char lout[]);
int variable(char lout[]);
int transl(char lin[],char lout[]);

//==================main======================
void main(int argc,char *argv[])
{

 char filename[20],fprg[20],fcpp[20];
 cout << "COMPIL.EXE  Copyright Farin S.L. 2005\n The sample compiler.\n";

 if (argc==2)
   strcpy(filename,argv[1]);
   else {
	cout << "Input file name:";
	cin >> filename;
   }
 strcpy(fprg,filename);
 strcat(fprg,".prg");
 strcpy(fcpp,filename);
 strcat(fcpp,".cpp");

 if ((prg = fopen (fprg,"rt"))==NULL)
    { cout << "Cannot open \""<<fprg<<"\".\n";
	   return ;
    }
 if ((cpp = fopen (fcpp,"wt"))==NULL)
    { cout << "Cannot open \""<<fcpp<<"\".\n";
	   return ;
    }
 cout << "Compile "<<fprg<<" ===> "<<fcpp<<".\n";
 int numlin=0;
 char linein[LL];
 char lineout[LL];
  while (!feof(prg))
   {
     fgets(linein,LL,prg);
     linein[strlen(linein)-1]='\0';
     numlin++;
     if (transl(linein,lineout))
	  {fputs(lineout,cpp);
	   cout << "Line #"<<numlin<<" - Ok!\n";}
	else cout
	<<"Error in Line #"<<numlin<<": "<<error_mes<<"\n";
     if (strstr(strlwr(linein),"end.")) break;
   }

 fclose(prg);
 fclose(cpp);
 cout << "To exit press ENTER.\n";
 cin.get();
 return ;
} //main
//=============================================
 //===============expr=========================
int expr(char lin[],char lout[])
{char *tmp=NULL, *varname=NULL, expres[LL]="";
 //udalit probely
 int i=0;
 int j=0;
 while(lin[i])
   if (isspace(lin[i])) i++;
      else expres[j++]=lin[i++];
 expres[j]='\0';

tmp=strstr(expres,words[9]);
*tmp='\0';
strcpy(varname,expres);
tmp=tmp+2;
strcpy(expres,tmp);
if (isvar(varname))
  {
   strcpy(lout,"  ");
   strcat(lout,varname);
   strcat(lout,"=");
   if(strrchr(expres,terminator)) strcat(lout,expres);
      else {strcpy(error_mes,"Not ;."); return 0;}
   } else {strcpy(error_mes,"Not variable."); return 0;}
strcat(lout,"\n");
return 1;
} //expr
//================isvar========================
int isvar(char varname[])
{ int y=0;
  for (int i=0; i<numvar; i++)
    if (strcmp(var[i],varname)==0) y=1;
  return y;
}//isvar
//================write========================
int write(char lin[],char lout[],int slowo)
{
 strcpy(lout,"  ");
 strcat(lout,wordn[5]);
 char *outlist,*ptr=NULL, item[40]="";
 if (outlist=strchr(lin,blist))
    {
     outlist++;
     if (strrchr(outlist,terminator))
	{
	 if (ptr=strrchr(outlist,elist))
	   {
	    *ptr='\0';

	    for(int i=0; i<strlen(outlist);)
	      {
	       if (isalpha(outlist[i]))
		 {
		  int j=0;
		  item[j++]=outlist[i++];
		  while(isalnum(outlist[i]))
		    {
		     item[j++]=outlist[i++];
		    }
		  item[j]='\0';
		  if (isvar(item))
		    {
		     strcat(lout," << ");
		     strcat(lout,item);
		    } else {strcpy(error_mes,"Not variable."); return 0;}
		 }
	       if (outlist[i]==apostrof)
		  {
		   int j=0;
		   item[j++]='\"';
		   i++;
		   while(outlist[i]!=apostrof&& i< strlen(outlist))
		     {
		      item[j++]=outlist[i++];

		     }
		   if (outlist[i++]==apostrof)
		     {
		      item[j]='\"';
		      item[j+1]='\0';
		      strcat(lout," << ");
		      strcat(lout,item);
		     }else{strcpy(error_mes,"Not end of string."); return 0;}
		  }
	       i++;
	     }
	   } else{strcpy(error_mes,"Not )."); return 0;}
	}else {strcpy(error_mes,"Not ;."); return 0;}

    }else {strcpy(error_mes,"Not (."); return 0;}


 if (slowo==5) strcat(lout," << \'\\n\'");
 strcat(lout,";\n");
 return 1;
} //write
//================read========================
int read(char lin[],char lout[])
{
 strcpy(lout,"  ");
 strcat(lout,wordn[7]);
 char *varlist=NULL,*ptr=NULL, varname[40]="";


 if (varlist=strchr(lin,blist))
     { if (ptr=strchr(varlist,elist))
	 {  if (strchr(ptr,terminator))
	    { *ptr='\0';
	    varlist++;

		while (ptr=strchr(varlist,slist))
	       {*ptr='\0';
		strcpy(varname,varlist);
		if (isvar(varname))
		   { strcat(lout," >> ");  strcat(lout,varname);
		   } else {strcpy(error_mes,"Not variable.");return 0;}
		varlist=ptr+1;
		}
	     strcpy(varname,varlist);

	     if (isvar(varname))
		{ strcat(lout," >> "); strcat(lout,varname);
		} else  {strcpy(error_mes,"Not variable.");return 0;}

	    } else  {strcpy(error_mes,"Not ;.");return 0;}
	 } else {strcpy(error_mes,"Not ).");return 0;}
     }else {strcpy(error_mes,"Not (.");return 0;}

 strcat(lout,";\n");
 return 1;
}//read
//=================variable=====================
int variable(char lout[])
{ strcpy(lout,"");
  char tmp[LL];
  char *varname;
  char decl[LL];
  decl[0]='\0';
  //udalit probely
  int i=0;
  int j=0;
  while (declare[i])
   { if (isspace(declare[i])) i++;
	else tmp[j++]=declare[i++];
   }
  tmp[j]='\0';
  //poisk peremennyh

  j=0;
  strcpy(varname,"");
  for(i=0;i<=strlen(tmp);i++)
    {
     if (isalnum(tmp[i])) {varname[j++]=tmp[i]; varname[j]='\0';}
	else
	 switch (tmp[i])
	  {case slist:if (isalpha(varname[0]))
		    {
		    strcpy (var[numvar++],varname);
		    strcat (decl,varname);
		    strcat (decl,",");
		    j=0;
		    strcpy(varname,"");
		    break;
		    }
		    else return 0;
	   case sdeclare:if (isalpha(varname[0]))
		    {
		    strcpy (var[numvar++],varname);
		    strcat (decl,varname);
		    strcat (decl,";\n");
		    j=0;
		    strcpy(varname,"");
		    break;
		    }
		    else return 0;
	   case terminator:
		    if(strcmp(varname,words[1])==0)
			 {strcat(lout,wordn[1]);
			  strcat(lout," ");
			  strcat(lout,decl);
			  }

		    if(strcmp(varname,words[2])==0)
			 { strcat(lout,wordn[2]);
			    strcat(lout," ");
			    strcat(lout,decl);
			  }
		    j=0;
		    strcpy(varname,"");
		    strcpy(decl,"");
		    break;
	   }
    }
  return 1;
}//variable
//=================transl=====================
int transl(char lin[],char lout[])
{int slovo=-1;
 char tmp[LL];
 lout[0]='\0';
 //strlwr(lin);
 strcpy(tmp,lin);
 for (int i = 0;i< NW&&slovo==-1;i++)
   {
   if (strstr(tmp,words[i])) slovo=i;
   }

if(slovo<0 || slovo>NW-1) return 0; //error
   else
   { switch (slovo)
     {
     //var
     case 0:strcpy(lout,"#include <iostream.h>\nint main()\n{\n");
	    numline=0; declare[0]='\0';break;
     //integer
     case 1:if (numline<0) return 0;
	       else {strcat(declare,lin);numline++;}
	       break;
     //real
     case 2:if (numline<0) return 0;
	       else {strcat(declare,lin);numline++;}
	       break;
     //begin
     case 3:if (numline<0)
	       strcpy(lout,"#include <iostream.h>\nint main()\n{\n");
	       else return variable(lout);
	       break;
     //end
     case 4:strcpy(lout,"  cin.get();\n  cin.get();\n  return 0;\n}\n");break;
     //writeln
     case 5:
     //write
     case 6:return write(lin,lout,slovo);
     //readln read
     case 7:
     case 8:return read(lin,lout);
     //:=
     case 9:return expr(lin,lout);
     default:
     strcpy(lout,"  ");
     //strcat(lout,wordn[slovo]);
     strcat(lout,"\n");
     }
     return 1; //ok!
    }

}//transl
